﻿using ProjectPlane.Entities;
using ProjectPlane.Drawnings;

namespace ProjectPlane.Drawnings;

public static class ExtentionDrawningShip
{
    private static readonly string _separatorForObject = ":";

    public static DrawningShip? CreateDrawningShip(this string info)
    {
        string[] strs = info.Split(_separatorForObject);
        EntityShip? ship = EntityContainer.CreateEntityContainer(strs);
        if (ship != null)
        {
            return new DrawCont(ship.Speed, ship.Weight, ship.ShipColor, (ship as EntityContainer).ContainerColor, (ship as EntityContainer).Container, (ship as EntityContainer).Crane);
        }
        ship = EntityShip.CreateEntityShip(strs);
        if (ship != null)
        {
            return new DrawningShip(ship.Speed, ship.Weight, ship.ShipColor);
        }
        return null;
    }
    
    public static string GetDataForSave(this DrawningShip drawningShip)
    {
        string[]? array = drawningShip?.EntityShip?.GetStringRepresentation();
        if (array == null)
        {
            return string.Empty;
        }
        return string.Join(_separatorForObject, array);
    }

}
