﻿namespace ProjectPlane.Entities;
/// <summary>
///  Класс-сущность "Контейнеровоз"
/// </summary>
public class EntityContainer : EntityShip 
{   
    /// <summary>
    /// Цвет контейнера
    /// </summary>
    public Color ContainerColor { get; private set; }

    /// <summary>
    /// Признак наличия контейнера
    /// </summary>
    public bool Container { get; private set; }

    /// <summary>
    /// Признак наличия крана
    /// </summary>
    public bool Crane { get; private set; }

    public EntityContainer(int speed, double weight, Color shipColor, Color containerColor, bool container, bool crane) : base(speed, weight, shipColor)
    {
        ContainerColor = containerColor;
        Container = container;
        Crane = crane;
    }

    public void ContainerColorChange(Color newColor)
    {
        ContainerColor = newColor;
    }

    public override string[] GetStringRepresentation()
    {
        return new[] { nameof(EntityContainer), Speed.ToString(), Weight.ToString(), ShipColor.Name, ContainerColor.Name, Container.ToString(), Crane.ToString()};
    }
    
    public static EntityContainer? CreateEntityContainer(string[] strs)
    {
        if (strs.Length != 7 || strs[0] != nameof(EntityContainer))
        {
            return null;
        }

        return new EntityContainer(Convert.ToInt32(strs[1]), Convert.ToDouble(strs[2]), Color.FromName(strs[3]), Color.FromName(strs[4]), Convert.ToBoolean(strs[5]), Convert.ToBoolean(strs[6]));
    }

}
